/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.TipoServicioDAO;
import com.rjconsultores.ventaboletos.entidad.TipoServicio;

/**
 *
 * @author Rafius
 */
@SuppressWarnings("unchecked")
@Repository("tipoServicioDAO")
public class TipoServicioHibernateDAO extends GenericHibernateDAO<TipoServicio, Integer>
        implements TipoServicioDAO {

    @Autowired
    public TipoServicioHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

	@Override
    public List<TipoServicio> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.addOrder(Order.asc("descservicio"));

        return c.list();
    }

    public List<TipoServicio> buscar(String descservicio) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.eq("descservicio", descservicio));

        return c.list();
    }
    
    @Override
    public List<TipoServicio> buscarListaPorIds(List<Integer> tiposervicioIds) {
		Criteria c = this.makeCriteria();
		c.add(Restrictions.in("tiposervicioId", tiposervicioIds));
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}
}
